component: TeleopDiagnostic
proto_imports:
  - vehicle/sensors/cameras/diagnostics/diagnostic.proto
metric: TeleopMetric
namespace: zoox::vehicle::cammux
faults:
  - id: 1
    name: consumer_failed_initialization
    severity: WARNING
    description: "Failed to select streams"
  - id: 2
    name: encoder_failed_initialization
    severity: WARNING
    description: "Video encoder failed to initialize"
  - id: 3
    name: missing_invalid_image_data
    severity: WARNING
    description: "Missing or invalid source image data"
  - id: 4
    name: stream_mismatch
    severity: WARNING
    description: "Provided streams do not match as expected"
  - id: 5
    name: stream_specs_bad
    severity: WARNING
    description: "Failed to read available video streams configuration"
  - id: 6
    name: stream_unavailable
    severity: WARNING
    description: "Stream unavailable to publish"
    #freeze_frame: CameraConsumerFreezeFrame?
  - id: 7
    name: bad_configuration
    severity: WARNING
    description: "Video encoder configuration fails sanity checks"
  - id: 8
    name: unsupported_format
    severity: WARNING
    description: "Unsupported image format"
  - id: 9
    name: device_error
    severity: WARNING
    description: "Device is not avaiable or not working correctly"
  - id: 10
    name: encoder_error
    severity: WARNING
    description: "There was a critical fault in image encoding"
  - id: 11
    name: dropped_frames
    severity: WARNING
    description: "The encoder dropped one or more frames. The encoder is unable to keep up."
  - id: 12
    name: high_latency
    severity: WARNING
    description: "The encoder/dds publishing pipeline is taking too long."
  - id: 13
    name: low_frame_rate
    severity: WARNING
    description: "The encoder is publishing at a lower frame rate than is expected."
  - id: 14
    name: high_frame_rate
    severity: WARNING
    description: "The encoder is publishing at a higher frame rate than is expected."
  - id: 15
    name: bitrate_low_warn
    severity: WARNING
    description: "The encoder is publishing at a lower bitrate than is expected."
  - id: 16
    name: bitrate_high_warn
    severity: WARNING
    description: "The encoder is publishing at a higher bitrate than is expected."
  - id: 17
    name: stream_not_selected
    severity: INFO
    description: "Not publishing images because no camera streams in this process are being used by teleop"
